!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!		A 1D Discrete Dynamical System
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!---------- ---- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
 DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

 DOUBLE PRECISION x, lambda, beta

    lambda = PAR(1)
    beta   = PAR(2)
    x  = U(1)
    F(1) = lambda * x * DEXP(-beta*x)

 IF(IJAC.EQ.0)RETURN 
    DFDU(1,1)=lambda*(1 - beta*x)* DEXP(-beta*x)

 IF(IJAC.EQ.1)RETURN 
    DFDP(1,1) = x * DEXP(-beta*x)
    DFDP(1,2) = -beta * lambda * x * DEXP(-beta*x)

 END SUBROUTINE FUNC
!---------------------------------------------------------------------- 

 SUBROUTINE STPNT(NDIM,U,PAR,T)
!---------- ----- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: T
 DOUBLE PRECISION lambda, beta, x

    lambda = 0
    beta   = 1

    PAR(1) = lambda
    PAR(2) = beta

    x    = 0
    U(1) = x

 END SUBROUTINE STPNT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
 SUBROUTINE BCND 
 END SUBROUTINE BCND

 SUBROUTINE ICND 
 END SUBROUTINE ICND

 SUBROUTINE FOPT 
 END SUBROUTINE FOPT

 SUBROUTINE PVLS
 END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
