!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!              A 2D discrete dynamical system
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!---------- ---- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
 DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)

 DOUBLE PRECISION lambda, alpha, x, y

   lambda = PAR(1)
   alpha  = PAR(2)

   x = U(1)
   y = U(2)

   F(1) = lambda * x * DEXP(-y)
   F(2) = x * ( 1 - DEXP(-alpha*y)  )

 END SUBROUTINE FUNC
!---------------------------------------------------------------------- 

 SUBROUTINE STPNT(NDIM,U,PAR,T)
!---------- ----- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: T

 DOUBLE PRECISION lambda, alpha, x, y

   lambda = 0.d0
   alpha  = 40.d0

   PAR(1) = lambda
   PAR(2) = alpha

   x = 0.d0
   y = 0.d0

   U(1) = x
   U(2) = y

 END SUBROUTINE STPNT
!---------------------------------------------------------------------- 

 SUBROUTINE PVLS(NDIM,U,PAR)
!---------- ----

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)
 DOUBLE PRECISION, EXTERNAL :: GETP,GETU2

 DOUBLE PRECISION gamma

!  For stopping purposes, set PAR(3) equal to the value of x:
   PAR(3) = GETP('MAX',1,U)

!  For stopping purposes, set PAR(4) equal to the value of y:
   PAR(4) = GETP('MAX',2,U)

 END SUBROUTINE PVLS
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
 SUBROUTINE BCND 
 END SUBROUTINE BCND

 SUBROUTINE ICND 
 END SUBROUTINE ICND

 SUBROUTINE FOPT 
 END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

