!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!              A 2D discrete dynamical system
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP) 
!---------- ---- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM, ICP(*), IJAC
 DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
 DOUBLE PRECISION, INTENT(OUT) :: F(NDIM)
 DOUBLE PRECISION, INTENT(INOUT) :: DFDU(NDIM,NDIM), DFDP(NDIM,*)
 DOUBLE PRECISION x, y, lambda, alpha, beta, gamma

   x = U(1)
   y = U(2)

   lambda = PAR(1)
   alpha  = PAR(2)
   beta   = PAR(3)

   F(1) = lambda*x*(1-x) - alpha*x*y
   F(2) = beta*y + alpha*x*y 

 IF(IJAC.EQ.0)RETURN 

! The Jacobian matrix:
   DFDU(1,1) = lambda*(1-2*x) - alpha*y
   DFDU(1,2) =-alpha*x
   DFDU(2,1) = alpha*y 
   DFDU(2,2) = beta + alpha*x

 IF(IJAC.EQ.1)RETURN 

! The derivatives with respect to the parameters:

   DFDP(1,1) = x*(1-x) 
   DFDP(2,1) = 0. 

   DFDP(1,2) =-x*y 
   DFDP(2,2) = x*y 

   DFDP(1,3) = 0.
   DFDP(2,3) = y 

 END SUBROUTINE FUNC
!---------------------------------------------------------------------- 

 SUBROUTINE STPNT(NDIM,U,PAR,T)
!---------- ----- 

 IMPLICIT NONE
 INTEGER, INTENT(IN) :: NDIM
 DOUBLE PRECISION, INTENT(INOUT) :: U(NDIM),PAR(*)
 DOUBLE PRECISION, INTENT(IN) :: T
 DOUBLE PRECISION x, y, lambda, alpha, beta

   x = 0.
   y = 0

   lambda = 0.
   alpha  = 0.2
   beta   = 0.9

   PAR(1) = lambda
   PAR(2) = alpha
   PAR(3) = beta

   U(1) = x
   U(2) = y 

 END SUBROUTINE STPNT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
 SUBROUTINE PVLS
 END SUBROUTINE PVLS

 SUBROUTINE BCND 
 END SUBROUTINE BCND

 SUBROUTINE ICND 
 END SUBROUTINE ICND

 SUBROUTINE FOPT 
 END SUBROUTINE FOPT
!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 

